<div class="container">
  <form novalidate #addSingleEventForm="ngForm">

    <mat-form-field>
      <input matInput required [(ngModel)]="singleEvent.name" placeholder="Name" name="name">
      <mat-error *ngIf="addSingleEventForm.controls.name?.errors?.required">Name is required</mat-error>
    </mat-form-field>

    <mat-form-field>
      <mat-label>Type</mat-label>
      <mat-select name="type" [(ngModel)]="singleEvent.type" required>
        <mat-option *ngFor="let eventType of eventTypes" [value]="eventType">
          {{eventType}}
        </mat-option>
      </mat-select>
      <mat-error *ngIf="addSingleEventForm.controls.type?.errors?.required">Type is required</mat-error>
    </mat-form-field>

    <mat-form-field>
      <textarea matInput required [(ngModel)]="singleEvent.description" placeholder="Description" name="description">
      </textarea>
      <mat-error *ngIf="addSingleEventForm.controls.name?.errors?.required">Description is required</mat-error>
    </mat-form-field>

    <table>
      <tr>
        <td width="60%">
          <mat-form-field class="datePicker">
            <input required matInput [(ngModel)]="startDate" [matDatepicker]="startDatePicker" placeholder="Choose a start date" name="startDate" (ngModelChange)="startTimeChanged()"
            appStartDateValidator [startTime]="addSingleEventForm.value.startTime">
            <mat-datepicker-toggle matSuffix [for]="startDatePicker"></mat-datepicker-toggle>
            <mat-datepicker #startDatePicker></mat-datepicker>
            <mat-error *ngIf="addSingleEventForm.controls.startDate?.errors?.required">Start date is required</mat-error>
            <mat-error *ngIf="addSingleEventForm.controls.startDate?.errors?.startTimeRequired">Start time is required</mat-error>
            <mat-error *ngIf="addSingleEventForm.controls.startDate?.errors?.startDateBeforeNow">Start of event has to be in the future</mat-error>
          </mat-form-field>
        </td>
        <td width="40%">
          <ngb-timepicker [(ngModel)]="startTime" class="timePicker" name="startTime" (ngModelChange)="startTimeChanged()"></ngb-timepicker>
        </td>
      </tr>
    </table>

    <table>
      <tr>
        <td width="60%">
          <mat-form-field class="datePicker">
            <input required matInput [(ngModel)]="endDate" [matDatepicker]="endDatePicker" placeholder="Choose an end date" name="endDate" (ngModelChange)="endTimeChanged()"
            appEndDateValidator [startDate]="addSingleEventForm.value.startDate" [startTime]="addSingleEventForm.value.startTime" [endTime]="addSingleEventForm.value.endTime">
            <mat-datepicker-toggle matSuffix [for]="endDatePicker"></mat-datepicker-toggle>
            <mat-datepicker #endDatePicker></mat-datepicker>
            <mat-error *ngIf="addSingleEventForm.controls.endDate?.errors?.required">End date is required</mat-error>
            <mat-error *ngIf="addSingleEventForm.controls.endDate?.errors?.endTimeRequired">End time is required</mat-error>
            <mat-error *ngIf="addSingleEventForm.controls.endDate?.errors?.endDateBeforeStartTime">End of event has to be after start of event</mat-error>
          </mat-form-field>
        </td>
        <td width="40%">
          <ngb-timepicker [(ngModel)]="endTime" class="timePicker" name="endTime" (ngModelChange)="endTimeChanged()"></ngb-timepicker>
        </td>
      </tr>
    </table>

    <mat-form-field>
      <input type="text" required placeholder="Location" matInput [(ngModel)]="selectedLocationName"
      name="location" (keyup)="locationInvalidated()" [matAutocomplete]="autoLocation" (ngModelChange)="doFilterLocation()" appAutoCompleteValidator>
      <mat-error *ngIf="addSingleEventForm.controls.location?.errors?.required">Location is required</mat-error>
      <mat-error *ngIf="addSingleEventForm.controls.location?.errors?.optionSelected">Valid location has to be selected</mat-error>
    </mat-form-field>

    <mat-autocomplete autoActiveFirstOption #autoLocation="matAutocomplete" (optionSelected)="setSelectedLocation($event)" [displayWith]="displayFunctionLocation">
      <mat-option *ngFor="let location of filteredLocations" [value]="location">
        {{ location.name }}, {{ location.city}}
      </mat-option>
    </mat-autocomplete>

    <mat-form-field>
      <input type="text" required placeholder="Space" matInput [(ngModel)]="selectedSpaceName"
      name="space" (keyup)="spaceInvalidated()" [matAutocomplete]="autoSpace" (ngModelChange)="doFilterSpace()" appAutoCompleteValidator>
      <mat-error *ngIf="addSingleEventForm.controls.space?.errors?.required">Space is required</mat-error>
      <mat-error *ngIf="addSingleEventForm.controls.space?.errors?.optionSelected">Valid space has to be selected</mat-error>
    </mat-form-field>

    <mat-autocomplete autoActiveFirstOption #autoSpace="matAutocomplete" (optionSelected)="setSelectedSpace($event)" [displayWith]="displayFunctionSpace">
      <mat-option *ngFor="let space of filteredSpaces" [value]="space">
        {{ space.name }}
      </mat-option>
    </mat-autocomplete>

    <mat-form-field>
      <input type="text" required placeholder="Space layout" matInput [(ngModel)]="selectedSpaceLayoutName"
      name="spaceLayout" (keyup)="spaceLayoutInvalidated()" [matAutocomplete]="autoSpaceLayout" (ngModelChange)="doFilterSpaceLayout()" appAutoCompleteValidator>
      <mat-error *ngIf="addSingleEventForm.controls.spaceLayout?.errors?.required">Space Layout is required</mat-error>
      <mat-error *ngIf="addSingleEventForm.controls.spaceLayout?.errors?.optionSelected">Valid space layout has to be selected</mat-error>
    </mat-form-field>

    <mat-autocomplete autoActiveFirstOption #autoSpaceLayout="matAutocomplete" (optionSelected)="setSelectedSpaceLayout($event)" [displayWith]="displayFunctionSpaceLayout">
      <mat-option *ngFor="let spaceLayout of filteredSpaceLayouts" [value]="spaceLayout">
        {{ spaceLayout.name }}
      </mat-option>
    </mat-autocomplete>

    <div class="center">
      <button mat-raised-button id="addSpaceLayout" (click)="openSpaceLayoutDialog()" [disabled]="addSingleEventForm.controls.space?.errors?.optionSelected">Add new space layout</button>
    </div>

    <app-space-layout-sectors (selectedEmitter)="onSelectedEntityChanged($event)" [event]="singleEvent" [spaceLayout]="selectedSpaceLayout" *ngIf="selectedSpaceLayout"></app-space-layout-sectors>

    <mat-label *ngIf="selectedSpaceLayout?.groundFloors?.length !== 0 && selectedSpaceLayout" class="bigMatLabel"> Ground floors </mat-label>
    <mat-divider *ngIf="selectedSpaceLayout?.groundFloors?.length !== 0 && selectedSpaceLayout"></mat-divider>

    <ng-template *ngIf="selectedSpaceLayout" ngFor let-groundFloor [ngForOf]="selectedSpaceLayout.groundFloors" let-index="index" let-isLast="last">
      <mat-form-field>
        <mat-label [ngClass]="groundFloor.id === selectedEntity?.id ? 'selectedEntity' : ''">Ground floor {{groundFloor.name}} price:</mat-label>
        <input matInput type="number" id="groundFloorPrice{{index}}" name="groundFloorPrice{{index}}" [(ngModel)]="groundFloor.price" required pattern="^\d+$" placeholder="Price">
        <mat-error *ngIf="addSingleEventForm.controls['groundFloorPrice'+index]?.errors?.required">Price for groundfloor is required</mat-error>
        <mat-error *ngIf="addSingleEventForm.controls['groundFloorPrice'+index]?.errors?.pattern">Price for groundfloor has to be a positive integer</mat-error>
      </mat-form-field>
      <mat-form-field>
        <mat-label [ngClass]="groundFloor.id === selectedEntity?.id ? 'selectedEntity' : ''">Ground floor {{groundFloor.name}} capacity:</mat-label>
        <input matInput type="number" id="groundFloorCapacity{{index}}"  name="groundFloorCapacity{{index}}" [(ngModel)]="groundFloor.capacity" required pattern="^\d+$" placeholder="Price">
        <mat-error *ngIf="addSingleEventForm.controls['groundFloorCapacity'+index]?.errors?.required">Capacity for groundfloor is required</mat-error>
        <mat-error *ngIf="addSingleEventForm.controls['groundFloorCapacity'+index]?.errors?.pattern">Capacity for groundfloor has to be a positive integer</mat-error>
      </mat-form-field>
    </ng-template>

    <mat-label *ngIf="selectedSpaceLayout?.seaetSpaces?.length !== 0 && selectedSpaceLayout" class="bigMatLabel"> Seat spaces </mat-label>
    <mat-divider *ngIf="selectedSpaceLayout?.seaetSpaces?.length !== 0 && selectedSpaceLayout"></mat-divider>

    <ng-template *ngIf="selectedSpaceLayout" ngFor let-seatSpace [ngForOf]="selectedSpaceLayout.seatSpaces" let-index="index" let-isLast="last">
      <mat-form-field>
        <mat-label [ngClass]="seatSpace.id === selectedEntity?.id ? 'selectedEntity' : ''">Seat space {{seatSpace.name}} price:</mat-label>
        <input matInput type="number"  id="seatSpacePrice{{index}}" name="seatSpacePrice{{index}}" [(ngModel)]="seatSpace.price" required pattern="^\d+$" placeholder="Price">
        <mat-error *ngIf="addSingleEventForm.controls['seatSpacePrice'+index]?.errors?.required">Price for seatspace is required</mat-error>
        <mat-error *ngIf="addSingleEventForm.controls['seatSpacePrice'+index]?.errors?.pattern">Price for seatspace has to be a positve integer</mat-error>
      </mat-form-field>
    </ng-template>


    <mat-divider></mat-divider>

    <div class="center">
      <button mat-button id="addSingleEventConfirm" type="submit"  (click)="addSingleEvent(addSingleEventForm)" [disabled]="!addSingleEventForm.valid">Add Single Event</button>
    </div>

    <div class="center">
      <button mat-button (click)="cancellAddingEvent(addSingleEventForm)">Cancel</button>
    </div>

  </form>
</div>
